/*
 * File to define some flags and macros for dealing with variations
 * in babel/sidl generated code.
 *
 * ben allan, SNL/CA, Apr 4 2003
 */

/* dot-noted babel version used for cca-spec-babel */
#define CCASPEC_HAVE_BABEL 1.4.0

/* #define HAVE_BABEL_MAJOR_x */
#define HAVE_BABEL_MAJOR_0

/* #define HAVE_BABEL_MINOR_x_y */
#define HAVE_BABEL_MINOR_0_9

/* #define HAVE_BABEL_PATCH_x_y_z */


/* sidl base exception member function names for version above */
#define SIDL_EXCEPTION_getMessage      getNote
#define SIDL_EXCEPTION_setMessage      setNote
#define SIDL_EXCEPTION_getTrace        getTrace
#define SIDL_EXCEPTION_addToStackTrace add
#define SIDL_EXCEPTION_addToTrace      add

/* rendering of type array<long> from sidl to c++.
 * sometimes a template on long, int64_t or whatever else.
 * this is useful in making sure the type created inside an
 * impl body is the same that babel will paste on the
 * outside through the generator.
 */ 
#define SIDL_LONG_ARRAY1_TYPE   ::SIDL::array<int64_t>
#define SIDL_LONG_ARRAY1_PRIMITIVE   int64_t
/* and in some cases, array, scalar are not consistent. */
#define SIDL_LONG_TYPE     int64_t
