/*
 * File:          gov_cca_Services.h
 * Symbol:        gov.cca.Services-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side glue code for gov.cca.Services
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#ifndef included_gov_cca_Services_h
#define included_gov_cca_Services_h

/**
 * Symbol "gov.cca.Services" (version 0.8.5)
 * 
 *  The one interface all frameworks must implement. A unique instance
 * of this is given to each component. 
 */
struct gov_cca_Services__object;
struct gov_cca_Services__array;
typedef struct gov_cca_Services__object* gov_cca_Services;

/*
 * Includes for all header dependencies.
 */

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_gov_cca_CCAException_h
#include "gov_cca_CCAException.h"
#endif
#ifndef included_gov_cca_ComponentID_h
#include "gov_cca_ComponentID.h"
#endif
#ifndef included_gov_cca_ComponentRelease_h
#include "gov_cca_ComponentRelease.h"
#endif
#ifndef included_gov_cca_Port_h
#include "gov_cca_Port.h"
#endif
#ifndef included_gov_cca_TypeMap_h
#include "gov_cca_TypeMap.h"
#endif
#ifndef included_sidl_BaseException_h
#include "sidl_BaseException.h"
#endif
#ifndef included_sidl_BaseInterface_h
#include "sidl_BaseInterface.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_RuntimeException_h
#include "sidl_RuntimeException.h"
#endif
#ifndef included_sidl_SIDLException_h
#include "sidl_SIDLException.h"
#endif

#ifndef included_sidl_rmi_Call_h
#include "sidl_rmi_Call.h"
#endif
#ifndef included_sidl_rmi_Return_h
#include "sidl_rmi_Return.h"
#endif
#ifdef SIDL_C_HAS_INLINE
#ifndef included_gov_cca_Services_IOR_h
#include "gov_cca_Services_IOR.h"
#endif
#endif /* SIDL_C_HAS_INLINE */
#ifdef __cplusplus
extern "C" {
#endif

#if !defined(GOV_CCA_SERVICES_INLINE_DECL) && defined(SIDL_C_HAS_INLINE)
#if (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || defined(__INTEL_COMPILER) || !defined(__GNUC__)
#define GOV_CCA_SERVICES_INLINE_DECL inline
#else
#define GOV_CCA_SERVICES_INLINE_DECL extern inline
#endif
#endif /* inline preprocessor definitions */
/**
 * Method to enable/disable interface contract enforcement.
 */
void
gov_cca_Services__set_contracts(
  gov_cca_Services self,
  sidl_bool   enable,
  const char* enfFilename,
  sidl_bool   resetCounters,
  struct sidl_BaseInterface__object **_ex);

/**
 * Method to dump interface contract enforcement statistics.
 */
void
gov_cca_Services__dump_stats(
  gov_cca_Services self,
  const char* filename,
  const char* prefix,
  struct sidl_BaseInterface__object **_ex);

/**
 *  
 * Fetch a previously registered Port (defined by either 
 * addProvidePort or (more typically) registerUsesPort).  
 * @return Will return the Port (possibly waiting forever while
 * attempting to acquire it) or throw an exception. Does not return
 * NULL, even in the case where no connection has been made. 
 * If a Port is returned,
 * there is then a contract that the port will remain valid for use
 * by the caller until the port is released via releasePort(), or a 
 * Disconnect Event is successfully dispatched to the caller,
 * or a runtime exception (such as network failure) occurs during 
 * invocation of some function in the Port. 
 * <p>
 * Subtle interpretation: If the Component is not listening for
 * Disconnect events, then the framework has no clean way to
 * break the connection until after the component calls releasePort.
 * </p>
 * <p>The framework may go through some machinations to obtain
 * the port, possibly involving an interactive user or network 
 * queries, before giving up and throwing an exception.
 * </p>
 * 
 * @param portName The previously registered or provide port which
 * the component now wants to use.
 * @exception CCAException with the following types: NotConnected, PortNotDefined, 
 * NetworkError, OutOfMemory.
 */
GOV_CCA_SERVICES_INLINE_DECL
gov_cca_Port
gov_cca_Services_getPort(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  gov_cca_Port _result;
  _result = (*self->d_epv->f_getPort)(
    self->d_object,
    portName,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Get a previously registered Port (defined by
 * either addProvide or registerUses) and return that
 * Port if it is available immediately (already connected
 * without further connection machinations).
 * There is an contract that the
 * port will remain valid per the description of getPort.
 * @return The named port, if it exists and is connected or self-provided,
 * or NULL if it is registered and is not yet connected. Does not
 * return if the Port is neither registered nor provided, but rather
 * throws an exception.
 * @param portName registered or provided port that
 * the component now wants to use.
 * @exception CCAException with the following types: PortNotDefined, OutOfMemory.
 */
GOV_CCA_SERVICES_INLINE_DECL
gov_cca_Port
gov_cca_Services_getPortNonblocking(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  gov_cca_Port _result;
  _result = (*self->d_epv->f_getPortNonblocking)(
    self->d_object,
    portName,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Notifies the framework that this component is finished 
 * using the previously fetched Port that is named.     
 * The releasePort() method calls should be paired with 
 * getPort() method calls; however, an extra call to releasePort()
 * for the same name may (is not required to) generate an exception.
 * Calls to release ports which are not defined or have never be fetched
 * with one of the getPort functions generate exceptions.
 * @param portName The name of a port.
 * @exception CCAException with the following types: PortNotDefined, PortNotInUse.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_releasePort(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_releasePort)(
    self->d_object,
    portName,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Creates a TypeMap, potentially to be used in subsequent
 * calls to describe a Port.  Initially, this map is empty.
 */
GOV_CCA_SERVICES_INLINE_DECL
gov_cca_TypeMap
gov_cca_Services_createTypeMap(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  gov_cca_TypeMap _result;
  _result = (*self->d_epv->f_createTypeMap)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Register a request for a Port that will be retrieved subsequently 
 * with a call to getPort().
 * @param portName A string uniquely describing this port.  This string
 * must be unique for this component, over both uses and provides ports.
 * @param type A string desribing the type of this port.
 * @param properties A TypeMap describing optional properties
 * associated with this port. This can be a null pointer, which
 * indicates an empty list of properties.  Properties may be
 * obtained from createTypeMap or any other source.  The properties
 * be copied into the framework, and subsequent changes to the
 * properties object will have no effect on the properties
 * associated with this port.
 * In these properties, all frameworks recognize at least the
 * following keys and values in implementing registerUsesPort:
 * <pre>
 * key:              standard values (in string form)     default
 * "MAX_CONNECTIONS" any nonnegative integer, "unlimited".   1
 * "MIN_CONNECTIONS" any integer > 0.                        0
 * "ABLE_TO_PROXY"   "true", "false"                      "false"
 * </pre>
 * The component is not expected to work if the framework
 * has not satisfied the connection requirements.
 * The framework is allowed to return an error if it
 * is incapable of meeting the connection requirements,
 * e.g. it does not implement multiple uses ports.
 * The caller of registerUsesPort is not obligated to define
 * these properties. If left undefined, the default listed above is
 * assumed.
 * @exception CCAException with the following types: PortAlreadyDefined, OutOfMemory.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_registerUsesPort(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* in */ const char* type,
  /* in */ gov_cca_TypeMap properties,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_registerUsesPort)(
    self->d_object,
    portName,
    type,
    properties,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Notify the framework that a Port, previously registered by this
 * component but currently not in use, is no longer desired. 
 * Unregistering a port that is currently 
 * in use (i.e. an unreleased getPort() being outstanding) 
 * is an error.
 * @param portName The name of a registered Port.
 * @exception CCAException with the following types: UsesPortNotReleased, PortNotDefined.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_unregisterUsesPort(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_unregisterUsesPort)(
    self->d_object,
    portName,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Exposes a Port from this component to the framework.  
 * This Port is now available for the framework to connect 
 * to other components. 
 * @param inPort An abstract interface (tagged with CCA-ness
 * by inheriting from gov.cca.Port) the framework will
 * make available to other components.
 * 
 * @param portName string uniquely describing this port.  This string
 * must be unique for this component, over both uses and provides ports.
 * 
 * @param type string describing the type (class) of this port.
 * 
 * @param properties A TypeMap describing optional properties
 * associated with this port. This can be a null pointer, which
 * indicates an empty list of properties.  Properties may be
 * obtained from createTypeMap or any other source.  The properties
 * be copied into the framework, and subsequent changes to the
 * properties object will have no effect on the properties
 * associated with this port.
 * In these properties, all frameworks recognize at least the
 * following keys and values in implementing registerUsesPort:
 * <pre>
 * key:              standard values (in string form)     default
 * "MAX_CONNECTIONS" any nonnegative integer, "unlimited".   1
 * "MIN_CONNECTIONS" any integer > 0.                        0
 * "ABLE_TO_PROXY"   "true", "false"                      "false"
 * </pre>
 * The component is not expected to work if the framework
 * has not satisfied the connection requirements.
 * The framework is allowed to return an error if it
 * is incapable of meeting the connection requirements,
 * e.g. it does not implement multiple uses ports.
 * The caller of addProvidesPort is not obligated to define
 * these properties. If left undefined, the default listed above is
 * assumed.
 * @exception CCAException with the following types: PortAlreadyDefined, OutOfMemory.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_addProvidesPort(
  /* in */ gov_cca_Services self,
  /* in */ gov_cca_Port inPort,
  /* in */ const char* portName,
  /* in */ const char* type,
  /* in */ gov_cca_TypeMap properties,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_addProvidesPort)(
    self->d_object,
    inPort,
    portName,
    type,
    properties,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  Returns the complete list of the properties for a Port.  This
 * includes the properties defined when the port was registered
 * (these properties can be modified by the framework), two special
 * properties "cca.portName" and "cca.portType", and any other
 * properties that the framework wishes to disclose to the component.
 * The framework may also choose to provide only the subset of input
 * properties (i.e. from addProvidesPort/registerUsesPort) that it
 * will honor.      
 */
GOV_CCA_SERVICES_INLINE_DECL
gov_cca_TypeMap
gov_cca_Services_getPortProperties(
  /* in */ gov_cca_Services self,
  /* in */ const char* name,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  gov_cca_TypeMap _result;
  _result = (*self->d_epv->f_getPortProperties)(
    self->d_object,
    name,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  Notifies the framework that a previously exposed Port is no longer 
 * available for use. The Port being removed must exist
 * until this call returns, or a CCAException may occur.
 * @param portName The name of a provided Port.
 * @exception PortNotDefined. In general, the framework will not dictate 
 * when the component chooses to stop offering services.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_removeProvidesPort(
  /* in */ gov_cca_Services self,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_removeProvidesPort)(
    self->d_object,
    portName,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  
 * Get a reference to the component to which this 
 * Services object belongs. 
 */
GOV_CCA_SERVICES_INLINE_DECL
gov_cca_ComponentID
gov_cca_Services_getComponentID(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  gov_cca_ComponentID _result;
  _result = (*self->d_epv->f_getComponentID)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 *  Obtain a callback for component destruction.
 * @param callBack an object that implements the ComponentRelease
 * interface that will be called when the component is to be destroyed.
 * 
 * Register a callback to be executed when the component is going
 * to be destroyed.  During this callback, the Services object passed
 * through setServices will still be valid, but after all such
 * callbacks are made for a specific component, subsequent usage
 * of the Services object is not allowed/is undefined.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_registerForRelease(
  /* in */ gov_cca_Services self,
  /* in */ gov_cca_ComponentRelease callBack,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_registerForRelease)(
    self->d_object,
    callBack,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_addRef(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_addRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services_deleteRef(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f_deleteRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
GOV_CCA_SERVICES_INLINE_DECL
sidl_bool
gov_cca_Services_isSame(
  /* in */ gov_cca_Services self,
  /* in */ sidl_BaseInterface iobj,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f_isSame)(
    self->d_object,
    iobj,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
GOV_CCA_SERVICES_INLINE_DECL
sidl_bool
gov_cca_Services_isType(
  /* in */ gov_cca_Services self,
  /* in */ const char* name,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f_isType)(
    self->d_object,
    name,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Return the meta-data about the class implementing this interface.
 */
GOV_CCA_SERVICES_INLINE_DECL
sidl_ClassInfo
gov_cca_Services_getClassInfo(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  sidl_ClassInfo _result;
  _result = (*self->d_epv->f_getClassInfo)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */


/**
 * Cast method for interface and class type conversions.
 */
struct gov_cca_Services__object*
gov_cca_Services__cast(
  void* obj,
  sidl_BaseInterface* _ex);

/**
 * String cast method for interface and class type conversions.
 */
void*
gov_cca_Services__cast2(
  void* obj,
  const char* type,
  sidl_BaseInterface *_ex);

/**
 * Select and execute a method by name
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services__exec(
  /* in */ gov_cca_Services self,
  /* in */ const char* methodName,
  /* in */ sidl_rmi_Call inArgs,
  /* in */ sidl_rmi_Return outArgs,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f__exec)(
    self->d_object,
    methodName,
    inArgs,
    outArgs,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */

/**
 * Get the URL of the Implementation of this object (for RMI)
 */
GOV_CCA_SERVICES_INLINE_DECL
char*
gov_cca_Services__getURL(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  char* _result;
  _result = (*self->d_epv->f__getURL)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */

/**
 * On a remote object, addrefs the remote instance.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services__raddRef(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f__raddRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */

/**
 * TRUE if this object is remote, false if local
 */
GOV_CCA_SERVICES_INLINE_DECL
sidl_bool
gov_cca_Services__isRemote(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f__isRemote)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */

/**
 * TRUE if this object is remote, false if local
 */
sidl_bool
gov_cca_Services__isLocal(
  /* in */ gov_cca_Services self,
  /* out */ sidl_BaseInterface *_ex);
/**
 * Method to enable/disable method hooks invocation.
 */
GOV_CCA_SERVICES_INLINE_DECL
void
gov_cca_Services__set_hooks(
  /* in */ gov_cca_Services self,
  /* in */ sidl_bool enable,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_SERVICES_INLINE_DECL
{
  (*self->d_epv->f__set_hooks)(
    self->d_object,
    enable,
    _ex);
}
#else
;
#endif /* GOV_CCA_SERVICES_INLINE_DECL */

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in column-major order. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_createCol(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[]);

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in row-major order. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_createRow(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[]);

/**
 * Create a contiguous one-dimensional array with a lower index
 * of 0 and an upper index of len-1. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_create1d(int32_t len);

/**
 * Create a dense one-dimensional vector with a lower
 * index of 0 and an upper index of len-1. The initial data for this
 * new array is copied from data. This will increment the reference
 * count of each non-NULL object/interface reference in data.
 * 
 * This array owns and manages its data.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_create1dInit(
  int32_t len, 
  gov_cca_Services* data);

/**
 * Create a contiguous two-dimensional array in column-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_create2dCol(int32_t m, int32_t n);

/**
 * Create a contiguous two-dimensional array in row-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_create2dRow(int32_t m, int32_t n);

/**
 * Create an array that uses data (memory) from another
 * source. The initial contents are determined by the
 * data being borrowed.
 * Any time an element in the borrowed array is replaced
 * via a set call, deleteRef will be called on the
 * value being replaced if it is not NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_borrow(
  gov_cca_Services* firstElement,
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/**
 * If array is borrowed, allocate a new self-sufficient
 * array and copy the borrowed array into the new array;
 * otherwise, increment the reference count and return
 * the array passed in. Use this whenever you want to
 * make a copy of a method argument because arrays
 * passed into methods aren't guaranteed to exist after
 * the method call.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_smartCopy(
  struct gov_cca_Services__array *array);

/**
 * Increment the array's internal reference count by one.
 */
void
gov_cca_Services__array_addRef(
  struct gov_cca_Services__array* array);

/**
 * Decrement the array's internal reference count by one.
 * If the reference count goes to zero, destroy the array.
 * If the array isn't borrowed, this releases all the
 * object references held by the array.
 */
void
gov_cca_Services__array_deleteRef(
  struct gov_cca_Services__array* array);

/**
 * Retrieve element i1 of a(n) 1-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get1(
  const struct gov_cca_Services__array* array,
  const int32_t i1);

/**
 * Retrieve element (i1,i2) of a(n) 2-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get2(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2);

/**
 * Retrieve element (i1,i2,i3) of a(n) 3-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get3(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3);

/**
 * Retrieve element (i1,i2,i3,i4) of a(n) 4-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get4(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4);

/**
 * Retrieve element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get5(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5);

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get6(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6);

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array.
 */
gov_cca_Services
gov_cca_Services__array_get7(
  const struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7);

/**
 * Retrieve element indices of an n-dimensional array.
 * indices is assumed to have the right number of elements
 * for the dimension of array.
 */
gov_cca_Services
gov_cca_Services__array_get(
  const struct gov_cca_Services__array* array,
  const int32_t indices[]);

/**
 * Set element i1 of a(n) 1-dimensional array to value.
 */
void
gov_cca_Services__array_set1(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  gov_cca_Services const value);

/**
 * Set element (i1,i2) of a(n) 2-dimensional array to value.
 */
void
gov_cca_Services__array_set2(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  gov_cca_Services const value);

/**
 * Set element (i1,i2,i3) of a(n) 3-dimensional array to value.
 */
void
gov_cca_Services__array_set3(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  gov_cca_Services const value);

/**
 * Set element (i1,i2,i3,i4) of a(n) 4-dimensional array to value.
 */
void
gov_cca_Services__array_set4(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  gov_cca_Services const value);

/**
 * Set element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array to value.
 */
void
gov_cca_Services__array_set5(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  gov_cca_Services const value);

/**
 * Set element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array to value.
 */
void
gov_cca_Services__array_set6(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  gov_cca_Services const value);

/**
 * Set element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array to value.
 */
void
gov_cca_Services__array_set7(
  struct gov_cca_Services__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7,
  gov_cca_Services const value);

/**
 * Set element indices of an n-dimensional array to value.indices is assumed to have the right number of elements
 * for the dimension of array.
 */
void
gov_cca_Services__array_set(
  struct gov_cca_Services__array* array,
  const int32_t indices[],
  gov_cca_Services const value);

/**
 * Return the dimension of array. If the array pointer is
 * NULL, zero is returned.
 */
int32_t
gov_cca_Services__array_dimen(
  const struct gov_cca_Services__array* array);

/**
 * Return the lower bound of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_Services__array_lower(
  const struct gov_cca_Services__array* array,
  const int32_t ind);

/**
 * Return the upper bound of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_Services__array_upper(
  const struct gov_cca_Services__array* array,
  const int32_t ind);

/**
 * Return the length of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_Services__array_length(
  const struct gov_cca_Services__array* array,
  const int32_t ind);

/**
 * Return the stride of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_Services__array_stride(
  const struct gov_cca_Services__array* array,
  const int32_t ind);

/**
 * Return a true value iff the array is a contiguous
 * column-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
gov_cca_Services__array_isColumnOrder(
  const struct gov_cca_Services__array* array);

/**
 * Return a true value iff the array is a contiguous
 * row-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
gov_cca_Services__array_isRowOrder(
  const struct gov_cca_Services__array* array);

/**
 * Create a sub-array of another array. This resulting
 * array shares data with the original array. The new
 * array can be of the same dimension or potentially
 * less assuming the original array has dimension
 * greater than 1.  If you are removing dimension,
 * indicate the dimensions to remove by setting
 * numElem[i] to zero for any dimension i wthat should
 * go away in the new array.  The meaning of each
 * argument is covered below.
 * 
 * src       the array to be created will be a subset
 *           of this array. If this argument is NULL,
 *           NULL will be returned. The array returned
 *           borrows data from src, so modifying src or
 *           the returned array will modify both
 *           arrays.
 * 
 * dimen     this argument must be greater than zero
 *           and less than or equal to the dimension of
 *           src. An illegal value will cause a NULL
 *           return value.
 * 
 * numElem   this specifies how many elements from src
 *           should be taken in each dimension. A zero
 *           entry indicates that the dimension should
 *           not appear in the new array.  This
 *           argument should be an array with an entry
 *           for each dimension of src.  Passing NULL
 *           here will cause NULL to be returned.  If
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           greater than upper[i] for src or if
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           less than lower[i] for src, NULL will be
 *           returned.
 * 
 * srcStart  this array holds the coordinates of the
 *           first element of the new array. If this
 *           argument is NULL, the first element of src
 *           will be the first element of the new
 *           array. If non-NULL, this argument should
 *           be an array with an entry for each
 *           dimension of src.  If srcStart[i] is less
 *           than lower[i] for the array src, NULL will
 *           be returned.
 * 
 * srcStride this array lets you specify the stride
 *           between elements in each dimension of
 *           src. This stride is relative to the
 *           coordinate system of the src array. If
 *           this argument is NULL, the stride is taken
 *           to be one in each dimension.  If non-NULL,
 *           this argument should be an array with an
 *           entry for each dimension of src.
 * 
 * newLower  this argument is like lower in a create
 *           method. It sets the coordinates for the
 *           first element in the new array.  If this
 *           argument is NULL, the values indicated by
 *           srcStart will be used. If non-NULL, this
 *           should be an array with dimen elements.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_slice(
  struct gov_cca_Services__array* src,
  int32_t        dimen,
  const int32_t  numElem[],
  const int32_t  *srcStart,
  const int32_t  *srcStride,
  const int32_t  *newStart);

/**
 * Copy the contents of one array (src) to a second array
 * (dest). For the copy to take place, both arrays must
 * exist and be of the same dimension. This method will
 * not modify dest's size, index bounds, or stride; only
 * the array element values of dest may be changed by
 * this function. No part of src is ever changed by copy.
 * 
 * On exit, dest[i][j][k]... = src[i][j][k]... for all
 * indices i,j,k...  that are in both arrays. If dest and
 * src have no indices in common, nothing is copied. For
 * example, if src is a 1-d array with elements 0-5 and
 * dest is a 1-d array with elements 2-3, this function
 * will make the following assignments:
 *   dest[2] = src[2],
 *   dest[3] = src[3].
 * The function copied the elements that both arrays have
 * in common.  If dest had elements 4-10, this function
 * will make the following assignments:
 *   dest[4] = src[4],
 *   dest[5] = src[5].
 */
void
gov_cca_Services__array_copy(
  const struct gov_cca_Services__array* src,
  struct gov_cca_Services__array* dest);

/**
 * If necessary, convert a general matrix into a matrix
 * with the required properties. This checks the
 * dimension and ordering of the matrix.  If both these
 * match, it simply returns a new reference to the
 * existing matrix. If the dimension of the incoming
 * array doesn't match, it returns NULL. If the ordering
 * of the incoming array doesn't match the specification,
 * a new array is created with the desired ordering and
 * the content of the incoming array is copied to the new
 * array.
 * 
 * The ordering parameter should be one of the constants
 * defined in enum sidl_array_ordering
 * (e.g. sidl_general_order, sidl_column_major_order, or
 * sidl_row_major_order). If you specify
 * sidl_general_order, this routine will only check the
 * dimension because any matrix is sidl_general_order.
 * 
 * The caller assumes ownership of the returned reference
 * unless it's NULL.
 */
struct gov_cca_Services__array*
gov_cca_Services__array_ensure(
  struct gov_cca_Services__array* src,
  int32_t dimen,
  int     ordering);


#pragma weak gov_cca_Services__connectI

/**
 * RMI connector function for the class. (no addref)
 */
struct gov_cca_Services__object*
gov_cca_Services__connectI(const char * url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex);

#ifdef __cplusplus
}
#endif
#endif
