/*
 * File:          gov_cca_ports_ParameterPortFactory.h
 * Symbol:        gov.cca.ports.ParameterPortFactory-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side glue code for gov.cca.ports.ParameterPortFactory
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#ifndef included_gov_cca_ports_ParameterPortFactory_h
#define included_gov_cca_ports_ParameterPortFactory_h

/**
 * Symbol "gov.cca.ports.ParameterPortFactory" (version 0.8.5)
 * 
 *  This interface supercedes the ccaffeine 
 * ConfigurableParameterPortFactory,
 * the parameters library, and all the associated cruft that
 * gunked up a component. The component writer now just needs to
 * use this port and one or more typemaps.
 * 
 * All the function names and meanings are as identical to
 * the existing ccaffeine interfaces as possible. Most just have
 * a TypeMap argument added and modernized (stl) string usage.
 * Additional functions to support the full generality of TypeMap
 * have been added.
 * 
 * Each ParameterPort is defined on a typemap the component owns.
 * A component writer can define more than one such port for a component,
 * and each will show up as a ParameterPort for UI agents.
 * The component writer can choose to be notified of 
 * parameter reads and writes using the related Listener interfaces.
 * 
 * All strings (help, prompt, value, etc) passed to this 
 * interface must be free
 * of \n and other line-breaking characters if certain
 * ancient gui clients are going to be used. This limitation is
 * in the clients rather than the ParameterPort implementation.
 * Those clients are prone to compressing redundant whitespace 
 * as well. In a rosy future, these client limitations will go away.
 */
struct gov_cca_ports_ParameterPortFactory__object;
struct gov_cca_ports_ParameterPortFactory__array;
typedef struct gov_cca_ports_ParameterPortFactory__object* 
  gov_cca_ports_ParameterPortFactory;

/*
 * Includes for all header dependencies.
 */

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_gov_cca_CCAException_h
#include "gov_cca_CCAException.h"
#endif
#ifndef included_gov_cca_Services_h
#include "gov_cca_Services.h"
#endif
#ifndef included_gov_cca_TypeMap_h
#include "gov_cca_TypeMap.h"
#endif
#ifndef included_gov_cca_ports_ParameterGetListener_h
#include "gov_cca_ports_ParameterGetListener.h"
#endif
#ifndef included_gov_cca_ports_ParameterSetListener_h
#include "gov_cca_ports_ParameterSetListener.h"
#endif
#ifndef included_sidl_BaseException_h
#include "sidl_BaseException.h"
#endif
#ifndef included_sidl_BaseInterface_h
#include "sidl_BaseInterface.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_RuntimeException_h
#include "sidl_RuntimeException.h"
#endif
#ifndef included_sidl_SIDLException_h
#include "sidl_SIDLException.h"
#endif

#ifndef included_sidl_rmi_Call_h
#include "sidl_rmi_Call.h"
#endif
#ifndef included_sidl_rmi_Return_h
#include "sidl_rmi_Return.h"
#endif
#ifdef SIDL_C_HAS_INLINE
#ifndef included_gov_cca_ports_ParameterPortFactory_IOR_h
#include "gov_cca_ports_ParameterPortFactory_IOR.h"
#endif
#endif /* SIDL_C_HAS_INLINE */
#ifdef __cplusplus
extern "C" {
#endif

#if !defined(GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL) && defined(SIDL_C_HAS_INLINE)
#if (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L)) || defined(__INTEL_COMPILER) || !defined(__GNUC__)
#define GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL inline
#else
#define GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL extern inline
#endif
#endif /* inline preprocessor definitions */
/**
 * Method to enable/disable interface contract enforcement.
 */
void
gov_cca_ports_ParameterPortFactory__set_contracts(
  gov_cca_ports_ParameterPortFactory self,
  sidl_bool   enable,
  const char* enfFilename,
  sidl_bool   resetCounters,
  struct sidl_BaseInterface__object **_ex);

/**
 * Method to dump interface contract enforcement statistics.
 */
void
gov_cca_ports_ParameterPortFactory__dump_stats(
  gov_cca_ports_ParameterPortFactory self,
  const char* filename,
  const char* prefix,
  struct sidl_BaseInterface__object **_ex);

/**
 *  Initialize the portData for use in a ParameterPort
 * with name portName.
 * More than one such port can be defined.
 * The given string portName will be cached in the TypeMap
 * as the result of this function and must not be changed
 * by the component henceforth.
 * 
 * @param portData the user-supplied TypeMap associated with the port;
 * It is somehow shared between the ParameterPortFactory
 * and the component. The ParameterPortFactory will
 * not read or change preexisting values in portData except those
 * requested via the addRequest functions and those
 * keys starting with the reserved prefix "gcpPPF.".
 * @param portName The name of the ParameterPort to appear in
 * the component. It must not conflict with other port
 * names in the same component. The port name "CONFIG"
 * is recommended if only one ParameterPort is being defined.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_initParameterData(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* inout */ gov_cca_TypeMap* portData,
  /* in */ const char* portName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_initParameterData)(
    self->d_object,
    portData,
    portName,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define the window title for the parameter UI dialog.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_setBatchTitle(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* title,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_setBatchTitle)(
    self->d_object,
    portData,
    title,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define the next tab/group title to use. All
 * addRequest subsequent calls will add to this group.
 * Multiple dialog tabs/groups can be defined in this way.
 * @param newGroupName a one-word name for the group.
 * @param portData the hash-table which we're subsetting
 * with a tab notation.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_setGroupName(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* newGroupName,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_setGroupName)(
    self->d_object,
    portData,
    newGroupName,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define the next tab/group title to use. All
 * addRequest subsequent calls will add to this group.
 * Multiple dialog tabs/groups can be defined in this way.
 * @param portData the hash-table which we're subsetting
 * with a tab notation.
 * @param newGroupName a one-word name for the group.
 * @param groupTitle an optional title for the group.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_setGroupNameAndTitle(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* newGroupName,
  /* in */ const char* groupTitle,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_setGroupNameAndTitle)(
    self->d_object,
    portData,
    newGroupName,
    groupTitle,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a boolean parameter and its default state.
 * The configured value is always available by
 * portData.getBool(name, ...);
 * @throws gov.cca.CCAException if key is known and mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestBoolean(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ sidl_bool bdefault,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestBoolean)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    bdefault,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a int parameter and its default state.
 * The configured value is always available by
 * portData.getInt(name, ...) and it will be
 * in the range [low, high]. The initially given bounds
 * can be replaced with a choice list later.
 * @throws gov.cca.CCAException if key is known and mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestInt(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ int32_t idefault,
  /* in */ int32_t low,
  /* in */ int32_t high,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestInt)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    idefault,
    low,
    high,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a long parameter and its default state.
 * The configured value is always available by
 * portData.getLong(name, ...) and it will be
 * in the range [low, high]. The initially given bounds
 * can be replaced with a choice list later.
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestLong(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ int64_t ldefault,
  /* in */ int64_t low,
  /* in */ int64_t high,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestLong)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    ldefault,
    low,
    high,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a float parameter and its default state.
 * The configured value is always available by
 * portData.getFloat(name, ...) and it will be
 * in the range [low, high]. The initially given bounds
 * can be replaced with a choice list later.
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestFloat(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ float fdefault,
  /* in */ float low,
  /* in */ float high,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestFloat)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    fdefault,
    low,
    high,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a double parameter and its default state.
 * The configured value is always available by
 * portData.getDouble(name, ...) and it will be
 * in the range [low, high]. The initially given bounds
 * can be replaced with a choice list later.
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestDouble(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ double ddefault,
  /* in */ double low,
  /* in */ double high,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestDouble)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    ddefault,
    low,
    high,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a string parameter and its default state.
 * The configured value is always available by
 * portData.getString(name, ...).
 * If no addRequestStringChoice calls are made, the
 * user input may be any string. If addRequestStringChoice
 * is used, the value will be one among the choices.
 * If addRequestStringChoice is used, deflt must
 * be among the choices defined.
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestString(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in */ const char* help,
  /* in */ const char* prompt,
  /* in */ const char* sdefault,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestString)(
    self->d_object,
    portData,
    name,
    help,
    prompt,
    sdefault,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Define a new choice for a string parameter.
 * If no calls to this function are made for a given
 * name, then any form of string will be acceptable input.
 * @throws gov.cca.CCAException if key is unknown or mistyped.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRequestStringChoice(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* key,
  /* in */ const char* choice,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRequestStringChoice)(
    self->d_object,
    portData,
    key,
    choice,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  As addRequestStringChoice, but in bulk. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addStringChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<string> */ struct sidl_string__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addStringChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addIntChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<int> */ struct sidl_int__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addIntChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addLongChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<long> */ struct sidl_long__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addLongChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addFloatChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<float> */ struct sidl_float__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addFloatChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addDoubleChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<double> */ struct sidl_double__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addDoubleChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addFcomplexChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<fcomplex> */ struct sidl_fcomplex__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addFcomplexChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Replace the bounds on the named parameter by a list. 
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addDcomplexChoices(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ const char* name,
  /* in array<dcomplex> */ struct sidl_dcomplex__array* choices,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addDcomplexChoices)(
    self->d_object,
    portData,
    name,
    choices,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Clear all previously added requests, titles, groups. After
 * this call, it is as if the ParameterPort has
 * seen initParameterData but otherwise never configured.
 * The values of
 * previously defined parameters (but not bounds, etc)
 * remain in the TypeMap.
 * Typically, this is used only by someone implementing
 * the updateParameterPort function from
 * interface ParameterGetListener.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_clearRequests(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_clearRequests)(
    self->d_object,
    portData,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  
 * Register listener (the component) that wishes to have
 * a chance to change the contents of its ParameterPort
 * just before the parameters TypeMap, portData, is read.
 * @param powner a pointer to the listener that will be
 * forgotten when it is no longer needed. 
 * @param portData the hash-table being accessed.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_registerUpdater(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ gov_cca_ports_ParameterGetListener powner,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_registerUpdater)(
    self->d_object,
    portData,
    powner,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Register listener (the component) if it wishes to be
 * informed when an parameter is changed via writeConfigurationMap.
 * Listeners are called after values are set.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_registerUpdatedListener(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ gov_cca_ports_ParameterSetListener powner,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_registerUpdatedListener)(
    self->d_object,
    portData,
    powner,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Signal that the ParameterPort is fully defined and should
 * now pop out on the component.
 * The component is free to hold the portData map internally
 * without adding it until some desired time.
 * The Services passed here
 * must be the component's own Services handle.
 * The ParameterPortFactory takes care of addProvidesPort.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addParameterPort(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ gov_cca_Services services,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addParameterPort)(
    self->d_object,
    portData,
    services,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 *  Cause a previously defined parameter port to go away.
 * This function should be called at component shutdown
 * (setService(0)) time for any parameter ports that have
 * been added but not yet removed.
 * The ParameterPortFactory takes care of removeProvidesPort.
 * This does not change the parameter values in the
 * TypeMap.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_removeParameterPort(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ gov_cca_TypeMap portData,
  /* in */ gov_cca_Services services,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_removeParameterPort)(
    self->d_object,
    portData,
    services,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_addRef(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_addRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory_deleteRef(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f_deleteRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
sidl_bool
gov_cca_ports_ParameterPortFactory_isSame(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ sidl_BaseInterface iobj,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f_isSame)(
    self->d_object,
    iobj,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
sidl_bool
gov_cca_ports_ParameterPortFactory_isType(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ const char* name,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f_isType)(
    self->d_object,
    name,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * Return the meta-data about the class implementing this interface.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
sidl_ClassInfo
gov_cca_ports_ParameterPortFactory_getClassInfo(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  sidl_ClassInfo _result;
  _result = (*self->d_epv->f_getClassInfo)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */


/**
 * Cast method for interface and class type conversions.
 */
struct gov_cca_ports_ParameterPortFactory__object*
gov_cca_ports_ParameterPortFactory__cast(
  void* obj,
  sidl_BaseInterface* _ex);

/**
 * String cast method for interface and class type conversions.
 */
void*
gov_cca_ports_ParameterPortFactory__cast2(
  void* obj,
  const char* type,
  sidl_BaseInterface *_ex);

/**
 * Select and execute a method by name
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory__exec(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ const char* methodName,
  /* in */ sidl_rmi_Call inArgs,
  /* in */ sidl_rmi_Return outArgs,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f__exec)(
    self->d_object,
    methodName,
    inArgs,
    outArgs,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */

/**
 * Get the URL of the Implementation of this object (for RMI)
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
char*
gov_cca_ports_ParameterPortFactory__getURL(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  char* _result;
  _result = (*self->d_epv->f__getURL)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */

/**
 * On a remote object, addrefs the remote instance.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory__raddRef(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f__raddRef)(
    self->d_object,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */

/**
 * TRUE if this object is remote, false if local
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
sidl_bool
gov_cca_ports_ParameterPortFactory__isRemote(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  sidl_bool _result;
  _result = (*self->d_epv->f__isRemote)(
    self->d_object,
    _ex);
  return _result;
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */

/**
 * TRUE if this object is remote, false if local
 */
sidl_bool
gov_cca_ports_ParameterPortFactory__isLocal(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* out */ sidl_BaseInterface *_ex);
/**
 * Method to enable/disable method hooks invocation.
 */
GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
void
gov_cca_ports_ParameterPortFactory__set_hooks(
  /* in */ gov_cca_ports_ParameterPortFactory self,
  /* in */ sidl_bool enable,
  /* out */ sidl_BaseInterface *_ex)
#ifdef GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL
{
  (*self->d_epv->f__set_hooks)(
    self->d_object,
    enable,
    _ex);
}
#else
;
#endif /* GOV_CCA_PORTS_PARAMETERPORTFACTORY_INLINE_DECL */

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in column-major order. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_createCol(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[]);

/**
 * Create a contiguous array of the given dimension with specified
 * index bounds in row-major order. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_createRow(
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[]);

/**
 * Create a contiguous one-dimensional array with a lower index
 * of 0 and an upper index of len-1. This array
 * owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_create1d(int32_t len);

/**
 * Create a dense one-dimensional vector with a lower
 * index of 0 and an upper index of len-1. The initial data for this
 * new array is copied from data. This will increment the reference
 * count of each non-NULL object/interface reference in data.
 * 
 * This array owns and manages its data.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_create1dInit(
  int32_t len, 
  gov_cca_ports_ParameterPortFactory* data);

/**
 * Create a contiguous two-dimensional array in column-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_create2dCol(int32_t m, int32_t n);

/**
 * Create a contiguous two-dimensional array in row-major
 * order with a lower index of (0,0) and an upper index of
 * (m-1,n-1). This array owns and manages its data.
 * This function initializes the contents of the array to
 * NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_create2dRow(int32_t m, int32_t n);

/**
 * Create an array that uses data (memory) from another
 * source. The initial contents are determined by the
 * data being borrowed.
 * Any time an element in the borrowed array is replaced
 * via a set call, deleteRef will be called on the
 * value being replaced if it is not NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_borrow(
  gov_cca_ports_ParameterPortFactory* firstElement,
  int32_t       dimen,
  const int32_t lower[],
  const int32_t upper[],
  const int32_t stride[]);

/**
 * If array is borrowed, allocate a new self-sufficient
 * array and copy the borrowed array into the new array;
 * otherwise, increment the reference count and return
 * the array passed in. Use this whenever you want to
 * make a copy of a method argument because arrays
 * passed into methods aren't guaranteed to exist after
 * the method call.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_smartCopy(
  struct gov_cca_ports_ParameterPortFactory__array *array);

/**
 * Increment the array's internal reference count by one.
 */
void
gov_cca_ports_ParameterPortFactory__array_addRef(
  struct gov_cca_ports_ParameterPortFactory__array* array);

/**
 * Decrement the array's internal reference count by one.
 * If the reference count goes to zero, destroy the array.
 * If the array isn't borrowed, this releases all the
 * object references held by the array.
 */
void
gov_cca_ports_ParameterPortFactory__array_deleteRef(
  struct gov_cca_ports_ParameterPortFactory__array* array);

/**
 * Retrieve element i1 of a(n) 1-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get1(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1);

/**
 * Retrieve element (i1,i2) of a(n) 2-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get2(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2);

/**
 * Retrieve element (i1,i2,i3) of a(n) 3-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get3(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3);

/**
 * Retrieve element (i1,i2,i3,i4) of a(n) 4-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get4(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4);

/**
 * Retrieve element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get5(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5);

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get6(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6);

/**
 * Retrieve element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get7(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7);

/**
 * Retrieve element indices of an n-dimensional array.
 * indices is assumed to have the right number of elements
 * for the dimension of array.
 */
gov_cca_ports_ParameterPortFactory
gov_cca_ports_ParameterPortFactory__array_get(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t indices[]);

/**
 * Set element i1 of a(n) 1-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set1(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2) of a(n) 2-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set2(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2,i3) of a(n) 3-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set3(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2,i3,i4) of a(n) 4-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set4(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2,i3,i4,i5) of a(n) 5-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set5(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2,i3,i4,i5,i6) of a(n) 6-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set6(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element (i1,i2,i3,i4,i5,i6,i7) of a(n) 7-dimensional array to value.
 */
void
gov_cca_ports_ParameterPortFactory__array_set7(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t i1,
  const int32_t i2,
  const int32_t i3,
  const int32_t i4,
  const int32_t i5,
  const int32_t i6,
  const int32_t i7,
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Set element indices of an n-dimensional array to value.indices is assumed to have the right number of elements
 * for the dimension of array.
 */
void
gov_cca_ports_ParameterPortFactory__array_set(
  struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t indices[],
  gov_cca_ports_ParameterPortFactory const value);

/**
 * Return the dimension of array. If the array pointer is
 * NULL, zero is returned.
 */
int32_t
gov_cca_ports_ParameterPortFactory__array_dimen(
  const struct gov_cca_ports_ParameterPortFactory__array* array);

/**
 * Return the lower bound of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_ports_ParameterPortFactory__array_lower(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t ind);

/**
 * Return the upper bound of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_ports_ParameterPortFactory__array_upper(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t ind);

/**
 * Return the length of dimension ind.
 * If ind is not a valid dimension, -1 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_ports_ParameterPortFactory__array_length(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t ind);

/**
 * Return the stride of dimension ind.
 * If ind is not a valid dimension, 0 is returned.
 * The valid range for ind is from 0 to dimen-1.
 */
int32_t
gov_cca_ports_ParameterPortFactory__array_stride(
  const struct gov_cca_ports_ParameterPortFactory__array* array,
  const int32_t ind);

/**
 * Return a true value iff the array is a contiguous
 * column-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
gov_cca_ports_ParameterPortFactory__array_isColumnOrder(
  const struct gov_cca_ports_ParameterPortFactory__array* array);

/**
 * Return a true value iff the array is a contiguous
 * row-major ordered array. A NULL array argument
 * causes 0 to be returned.
 */
int
gov_cca_ports_ParameterPortFactory__array_isRowOrder(
  const struct gov_cca_ports_ParameterPortFactory__array* array);

/**
 * Create a sub-array of another array. This resulting
 * array shares data with the original array. The new
 * array can be of the same dimension or potentially
 * less assuming the original array has dimension
 * greater than 1.  If you are removing dimension,
 * indicate the dimensions to remove by setting
 * numElem[i] to zero for any dimension i wthat should
 * go away in the new array.  The meaning of each
 * argument is covered below.
 * 
 * src       the array to be created will be a subset
 *           of this array. If this argument is NULL,
 *           NULL will be returned. The array returned
 *           borrows data from src, so modifying src or
 *           the returned array will modify both
 *           arrays.
 * 
 * dimen     this argument must be greater than zero
 *           and less than or equal to the dimension of
 *           src. An illegal value will cause a NULL
 *           return value.
 * 
 * numElem   this specifies how many elements from src
 *           should be taken in each dimension. A zero
 *           entry indicates that the dimension should
 *           not appear in the new array.  This
 *           argument should be an array with an entry
 *           for each dimension of src.  Passing NULL
 *           here will cause NULL to be returned.  If
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           greater than upper[i] for src or if
 *           srcStart[i] + numElem[i]*srcStride[i] is
 *           less than lower[i] for src, NULL will be
 *           returned.
 * 
 * srcStart  this array holds the coordinates of the
 *           first element of the new array. If this
 *           argument is NULL, the first element of src
 *           will be the first element of the new
 *           array. If non-NULL, this argument should
 *           be an array with an entry for each
 *           dimension of src.  If srcStart[i] is less
 *           than lower[i] for the array src, NULL will
 *           be returned.
 * 
 * srcStride this array lets you specify the stride
 *           between elements in each dimension of
 *           src. This stride is relative to the
 *           coordinate system of the src array. If
 *           this argument is NULL, the stride is taken
 *           to be one in each dimension.  If non-NULL,
 *           this argument should be an array with an
 *           entry for each dimension of src.
 * 
 * newLower  this argument is like lower in a create
 *           method. It sets the coordinates for the
 *           first element in the new array.  If this
 *           argument is NULL, the values indicated by
 *           srcStart will be used. If non-NULL, this
 *           should be an array with dimen elements.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_slice(
  struct gov_cca_ports_ParameterPortFactory__array* src,
  int32_t        dimen,
  const int32_t  numElem[],
  const int32_t  *srcStart,
  const int32_t  *srcStride,
  const int32_t  *newStart);

/**
 * Copy the contents of one array (src) to a second array
 * (dest). For the copy to take place, both arrays must
 * exist and be of the same dimension. This method will
 * not modify dest's size, index bounds, or stride; only
 * the array element values of dest may be changed by
 * this function. No part of src is ever changed by copy.
 * 
 * On exit, dest[i][j][k]... = src[i][j][k]... for all
 * indices i,j,k...  that are in both arrays. If dest and
 * src have no indices in common, nothing is copied. For
 * example, if src is a 1-d array with elements 0-5 and
 * dest is a 1-d array with elements 2-3, this function
 * will make the following assignments:
 *   dest[2] = src[2],
 *   dest[3] = src[3].
 * The function copied the elements that both arrays have
 * in common.  If dest had elements 4-10, this function
 * will make the following assignments:
 *   dest[4] = src[4],
 *   dest[5] = src[5].
 */
void
gov_cca_ports_ParameterPortFactory__array_copy(
  const struct gov_cca_ports_ParameterPortFactory__array* src,
  struct gov_cca_ports_ParameterPortFactory__array* dest);

/**
 * If necessary, convert a general matrix into a matrix
 * with the required properties. This checks the
 * dimension and ordering of the matrix.  If both these
 * match, it simply returns a new reference to the
 * existing matrix. If the dimension of the incoming
 * array doesn't match, it returns NULL. If the ordering
 * of the incoming array doesn't match the specification,
 * a new array is created with the desired ordering and
 * the content of the incoming array is copied to the new
 * array.
 * 
 * The ordering parameter should be one of the constants
 * defined in enum sidl_array_ordering
 * (e.g. sidl_general_order, sidl_column_major_order, or
 * sidl_row_major_order). If you specify
 * sidl_general_order, this routine will only check the
 * dimension because any matrix is sidl_general_order.
 * 
 * The caller assumes ownership of the returned reference
 * unless it's NULL.
 */
struct gov_cca_ports_ParameterPortFactory__array*
gov_cca_ports_ParameterPortFactory__array_ensure(
  struct gov_cca_ports_ParameterPortFactory__array* src,
  int32_t dimen,
  int     ordering);


#pragma weak gov_cca_ports_ParameterPortFactory__connectI

/**
 * RMI connector function for the class. (no addref)
 */
struct gov_cca_ports_ParameterPortFactory__object*
gov_cca_ports_ParameterPortFactory__connectI(const char * url, sidl_bool ar, 
  struct sidl_BaseInterface__object **_ex);

#ifdef __cplusplus
}
#endif
#endif
