// 
// File:          gov_cca_ports_ParameterPort.hxx
// Symbol:        gov.cca.ports.ParameterPort-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.ports.ParameterPort
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_ports_ParameterPort_hxx
#define included_gov_cca_ports_ParameterPort_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ParameterPort;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::ports::ParameterPort >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_ports_ParameterPort_IOR_h
#include "gov_cca_ports_ParameterPort_IOR.h"
#endif
#ifndef included_gov_cca_ports_BasicParameterPort_hxx
#include "gov_cca_ports_BasicParameterPort.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.ParameterPort" (version 0.8.5)
       * 
       *  This type of interface is exported for manipulation by other
       * components or by a user-interface (UI) (text or graphic).
       * By using the port ParameterFactory the component
       * writer never actually has to implement this port directly.
       * The recommended instance name for this port type is "CONFIG",
       * if a component provides only one such port. 
       * Component assembly or user interface rendering agents might 
       * assume this name. However, clever agents will act based on
       * port type rather than port instance name.
       * 
       * Data types represented: Anything representable in a TypeMap.
       * The following auxiliary information is managed for the benefit
       * of component end-user, UI, and other agents. 
       * Per map:
       * - title -- a name suitable to a top level window frame.
       * - group names -- data items are put in subsets (groups)
       * as, for example, in tabbed dialogs.
       * - list of all published parameter keys, those defined
       * with the add functions of ParameterPortFactory. 
       * Per group name:
       * - group title -- ui-appropriate subset title, typically a tab heading.
       * - group keys -- list of data item keys in a named group.
       * Per data item key:
       * - default value 
       * - current value -- queryable directly from TypeMap by key name.
       * - help string -- potentially long-winded explanation of parameter use.
       * - prompt string -- shorter than help string and usually shown
       * in UI somehow while soliciting input.
       * - numeric bounds or value choice list. Where data type is
       * an array type, the choice or bound restrictions are applied
       * element-wise.
       * 
       * 
       * Special notes:
       * - The rendering of array-valued parameters in UI's poses a variety
       * of thorny problems in human-computer interaction. Use of
       * array parameters should be considered carefully. Not all UI
       * agents may be able to render array-valued parameters.
       * - Keys in the TypeMap with names starting with "gcpPPF." are
       * reserved for private use by the 
       * ParameterPortFactory implementation.
       */
      class ParameterPort: public virtual ::gov::cca::ports::BasicParameterPort 
        {

        //////////////////////////////////////////////////
        // 
        // Special methods for throwing exceptions
        // 

      private:
        static 
        void
        throwException0(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
        ;
        static 
        void
        throwException1(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
          //    ::gov::cca::CCAException
          //    ::sidl::RuntimeException
        ;

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         *  Fetch configuration title. 
         * @return Description of data set.
         */
        ::std::string
        readTitle() ;


        /**
         *  Fetch the names of groups. Each page in a tabbed dialog
         * goes with a group, for example. Group names should be
         * a simple word without whitespace.
         */
        ::sidl::array< ::std::string>
        readGroupNames() ;


        /**
         *  Fetch UI-appropriate name for group.
         * Group name and group title may be the same, if simple.
         * Group title can be complex if desired.
         * @throws gov.cca.CCAException if groupName is unknown.
         */
        ::std::string
        readGroupTitle (
          /* in */const ::std::string& groupName
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch data item keys associated with groupName.
         * Array order will be the same as the order in which
         * the additions were made in the ParameterPortFactory interface.
         * @throws gov.cca.CCAException if groupName is unknown.
         */
        ::sidl::array< ::std::string>
        readGroupKeys (
          /* in */const ::std::string& groupName
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the help string for key.
         * @throws gov.cca.CCAException if key is unknown.
         */
        ::std::string
        readHelp (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the prompt string for key.
         * @throws gov.cca.CCAException if key is unknown.
         */
        ::std::string
        readPrompt (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  By default, bounds are defined except for complex numbers
         * booleans, and strings. On array types, bounds apply
         * element-wise. i.e.  low <= arr[i] <= high for all i.
         * @return true if simple bounds are defined for a key.
         * @throws gov.cca.CCAException if key is unknown.
         */
        bool
        hasBounds (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  By default, lists of choices are not defined for scalars or arrays.
         * Choices are applied element-wise for array types.
         * I.e. (arr[i] IN choice-set) == true  for all i.
         * @return true if choice list is defined for a key.
         * @throws gov.cca.CCAException if key is unknown.
         */
        bool
        hasChoices (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for boolean-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        bool
        readDefaultBoolean (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for string-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::std::string
        readDefaultString (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for integer-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        int32_t
        readDefaultInt (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for long-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        int64_t
        readDefaultLong (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for float-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        float
        readDefaultFloat (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for double-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        double
        readDefaultDouble (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for fcomplex-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::std::complex<float>
        readDefaultFcomplex (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for dcomplex-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::std::complex<double>
        readDefaultDcomplex (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for string-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::std::string>
        readDefaultStringArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for boolean-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<bool>
        readDefaultBooleanArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for integer-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<int32_t>
        readDefaultIntArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for long-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<int64_t>
        readDefaultLongArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for float-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<float>
        readDefaultFloatArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for double-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<double>
        readDefaultDoubleArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for fcomplex-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::sidl::fcomplex>
        readDefaultFcomplexArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for dcomplex-array-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::sidl::dcomplex>
        readDefaultDcomplexArray (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the bounds for integer-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        void
        readBoundsInt (
          /* in */const ::std::string& key,
          /* out */int32_t& low,
          /* out */int32_t& high
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the bounds for long-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        void
        readBoundsLong (
          /* in */const ::std::string& key,
          /* out */int64_t& low,
          /* out */int64_t& high
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the bounds for float-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        void
        readBoundsFloat (
          /* in */const ::std::string& key,
          /* out */float& low,
          /* out */float& high
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the bounds for double-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        void
        readBoundsDouble (
          /* in */const ::std::string& key,
          /* out */double& low,
          /* out */double& high
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for string-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::std::string>
        readChoicesString (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for integer-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<int32_t>
        readChoicesInt (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for long-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<int64_t>
        readChoicesLong (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for float-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<float>
        readChoicesFloat (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the default for double-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array<double>
        readChoicesDouble (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for fcomplex-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::sidl::fcomplex>
        readChoicesFcomplex (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Fetch the choices for dcomplex-typed key. 
         * @throws gov.cca.CCAException if key is unknown or mistyped.
         */
        ::sidl::array< ::sidl::dcomplex>
        readChoicesDcomplex (
          /* in */const ::std::string& key
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_ParameterPort__object ior_t;
        typedef struct gov_cca_ports_ParameterPort__external ext_t;
        typedef struct gov_cca_ports_ParameterPort__sepv sepv_t;

        // default constructor
        ParameterPort()  : gov_cca_ports_ParameterPort_IORCache((ior_t*) NULL){ 
          }

#ifdef WITH_RMI

        // RMI connect
        static inline ::gov::cca::ports::ParameterPort _connect( /*in*/ const 
          std::string& url ) { 
          return _connect(url, true);
        }

        // RMI connect 2
        static ::gov::cca::ports::ParameterPort _connect( /*in*/ const 
          std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

        // default destructor
        virtual ~ParameterPort () { }

        // copy constructor
        ParameterPort ( const ParameterPort& original );

        // assignment operator
        ParameterPort& operator= ( const ParameterPort& rhs );

        // conversion from ior to C++ class
        ParameterPort ( ParameterPort::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        ParameterPort ( ParameterPort::ior_t* ior, bool isWeak );

        inline ior_t* _get_ior() const throw() {
          if(!gov_cca_ports_ParameterPort_IORCache) { 
            gov_cca_ports_ParameterPort_IORCache = 
              ::gov::cca::ports::ParameterPort::_cast((void*)d_self);
            if (gov_cca_ports_ParameterPort_IORCache) {
              struct sidl_BaseInterface__object *throwaway_exception;
              (gov_cca_ports_ParameterPort_IORCache->d_epv->f_deleteRef)(
                gov_cca_ports_ParameterPort_IORCache->d_object, 
                &throwaway_exception);  
            }  
          }
          return gov_cca_ports_ParameterPort_IORCache;
        }

        inline void _set_ior( ior_t* ptr ) throw () { 
          d_self = reinterpret_cast< void*>(ptr);
          gov_cca_ports_ParameterPort_IORCache = (ior_t*) ptr;

          gov_cca_Port_IORCache = NULL;
          gov_cca_ports_BasicParameterPort_IORCache = NULL;
        }

        virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                       const ::std::type_info &argtype );

        bool _is_nil() const throw () { return (d_self==0); }

        bool _not_nil() const throw () { return (d_self!=0); }

        bool operator !() const throw () { return (d_self==0); }

        static inline const char * type_name() throw () { return 
          "gov.cca.ports.ParameterPort";}

        static struct gov_cca_ports_ParameterPort__object* _cast(const void* 
          src);

        // execute member function by name
        void _exec(const std::string& methodName,
                   ::sidl::rmi::Call& inArgs,
                   ::sidl::rmi::Return& outArgs);

        /**
         * Get the URL of the Implementation of this object (for RMI)
         */
        ::std::string
        _getURL() // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable method hooks invocation.
         */
        void
        _set_hooks (
          /* in */bool enable
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable interface contract enforcement.
         */
        void
        _set_contracts (
          /* in */bool enable,
          /* in */const ::std::string& enfFilename,
          /* in */bool resetCounters
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to dump contract enforcement statistics.
         */
        void
        _dump_stats (
          /* in */const ::std::string& filename,
          /* in */const ::std::string& prefix
        )
        // throws:
        //    ::sidl::RuntimeException
        ;

        // return true iff object is remote
        bool _isRemote() const { 
          ior_t* self = const_cast<ior_t*>(_get_ior() );
          struct sidl_BaseInterface__object *throwaway_exception;
          return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == 
            TRUE;
        }

        // return true iff object is local
        bool _isLocal() const {
          return !_isRemote();
        }

      protected:
        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


        //////////////////////////////////////////////////
        // 
        // Locally Cached IOR pointer
        // 

      protected:
        mutable ior_t* gov_cca_ports_ParameterPort_IORCache;
      }; // end class ParameterPort
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_ports_ParameterPort__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_ports_ParameterPort__object*
  gov_cca_ports_ParameterPort__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::ParameterPort > {
    typedef array< ::gov::cca::ports::ParameterPort > cxx_array_t;
    typedef ::gov::cca::ports::ParameterPort cxx_item_t;
    typedef struct gov_cca_ports_ParameterPort__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_ParameterPort__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::gov::cca::ports::ParameterPort > > 
      iterator;
    typedef const_array_iter< array_traits< ::gov::cca::ports::ParameterPort > 
      > const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::ParameterPort >: public interface_array< 
    array_traits< ::gov::cca::ports::ParameterPort > > {
  public:
    typedef interface_array< array_traits< ::gov::cca::ports::ParameterPort > > 
      Base;
    typedef array_traits< ::gov::cca::ports::ParameterPort >::cxx_array_t       
      cxx_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterPort >::cxx_item_t        
      cxx_item_t;
    typedef array_traits< ::gov::cca::ports::ParameterPort >::ior_array_t       
      ior_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterPort 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::ParameterPort >::ior_item_t        
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_ParameterPort__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::ParameterPort >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::ParameterPort >&
    operator =( const array< ::gov::cca::ports::ParameterPort >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
