// 
// File:          gov_cca_TypeMap.hxx
// Symbol:        gov.cca.TypeMap-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.TypeMap
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_TypeMap_hxx
#define included_gov_cca_TypeMap_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 

    class TypeMap;
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::TypeMap >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class TypeMap;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class TypeMismatchException;
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_TypeMap_IOR_h
#include "gov_cca_TypeMap_IOR.h"
#endif
#ifndef included_gov_cca_Type_hxx
#include "gov_cca_Type.hxx"
#endif
#ifndef included_sidl_BaseInterface_hxx
#include "sidl_BaseInterface.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 

    /**
     * Symbol "gov.cca.TypeMap" (version 0.8.5)
     * 
     *  
     * A CCA map.  Maps a string key to a particular value. Types are
     * strictly enforced.  For example, values places into the map
     * using putInt can be retrieved only using getInt.  Calls to
     * getLong, getString, getIntArray and other get methods will
     * fail (i.e. return the default value). 
     */
    class TypeMap: public virtual ::sidl::BaseInterface {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException1(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
        //    ::gov::cca::TypeMismatchException
        //    ::sidl::RuntimeException
      ;
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  Create an exact copy of this Map 
       */
      ::gov::cca::TypeMap
      cloneTypeMap() ;


      /**
       *  Create a new Map with no key/value associations. 
       */
      ::gov::cca::TypeMap
      cloneEmpty() ;

      /**
       * user defined non-static method
       */
      int32_t
      getInt (
        /* in */const ::std::string& key,
        /* in */int32_t dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      int64_t
      getLong (
        /* in */const ::std::string& key,
        /* in */int64_t dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      float
      getFloat (
        /* in */const ::std::string& key,
        /* in */float dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      double
      getDouble (
        /* in */const ::std::string& key,
        /* in */double dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::std::complex<float>
      getFcomplex (
        /* in */const ::std::string& key,
        /* in */const ::std::complex<float>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::std::complex<double>
      getDcomplex (
        /* in */const ::std::string& key,
        /* in */const ::std::complex<double>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::std::string
      getString (
        /* in */const ::std::string& key,
        /* in */const ::std::string& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      bool
      getBool (
        /* in */const ::std::string& key,
        /* in */bool dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array<int32_t>
      getIntArray (
        /* in */const ::std::string& key,
        /* in array<int> */const ::sidl::array<int32_t>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array<int64_t>
      getLongArray (
        /* in */const ::std::string& key,
        /* in array<long> */const ::sidl::array<int64_t>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array<float>
      getFloatArray (
        /* in */const ::std::string& key,
        /* in array<float> */const ::sidl::array<float>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array<double>
      getDoubleArray (
        /* in */const ::std::string& key,
        /* in array<double> */const ::sidl::array<double>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array< ::sidl::fcomplex>
      getFcomplexArray (
        /* in */const ::std::string& key,
        /* in array<fcomplex> */const ::sidl::array< ::sidl::fcomplex>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array< ::sidl::dcomplex>
      getDcomplexArray (
        /* in */const ::std::string& key,
        /* in array<dcomplex> */const ::sidl::array< ::sidl::dcomplex>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array< ::std::string>
      getStringArray (
        /* in */const ::std::string& key,
        /* in array<string> */const ::sidl::array< ::std::string>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      ::sidl::array<bool>
      getBoolArray (
        /* in */const ::std::string& key,
        /* in array<bool> */const ::sidl::array<bool>& dflt
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;



      /**
       *  
       * Assign a key and value. Any value previously assigned
       * to the same key will be overwritten so long as it
       * is of the same type. If types conflict, an exception occurs.
       */
      void
      putInt (
        /* in */const ::std::string& key,
        /* in */int32_t value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putLong (
        /* in */const ::std::string& key,
        /* in */int64_t value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putFloat (
        /* in */const ::std::string& key,
        /* in */float value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putDouble (
        /* in */const ::std::string& key,
        /* in */double value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putFcomplex (
        /* in */const ::std::string& key,
        /* in */const ::std::complex<float>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putDcomplex (
        /* in */const ::std::string& key,
        /* in */const ::std::complex<double>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putString (
        /* in */const ::std::string& key,
        /* in */const ::std::string& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putBool (
        /* in */const ::std::string& key,
        /* in */bool value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putIntArray (
        /* in */const ::std::string& key,
        /* in array<int> */const ::sidl::array<int32_t>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putLongArray (
        /* in */const ::std::string& key,
        /* in array<long> */const ::sidl::array<int64_t>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putFloatArray (
        /* in */const ::std::string& key,
        /* in array<float> */const ::sidl::array<float>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putDoubleArray (
        /* in */const ::std::string& key,
        /* in array<double> */const ::sidl::array<double>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putFcomplexArray (
        /* in */const ::std::string& key,
        /* in array<fcomplex> */const ::sidl::array< ::sidl::fcomplex>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putDcomplexArray (
        /* in */const ::std::string& key,
        /* in array<dcomplex> */const ::sidl::array< ::sidl::dcomplex>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putStringArray (
        /* in */const ::std::string& key,
        /* in array<string> */const ::sidl::array< ::std::string>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;


      /**
       * user defined non-static method
       */
      void
      putBoolArray (
        /* in */const ::std::string& key,
        /* in array<bool> */const ::sidl::array<bool>& value
      )
      // throws:
      //    ::gov::cca::TypeMismatchException
      //    ::sidl::RuntimeException
      ;



      /**
       *  Make the key and associated value disappear from the object. 
       */
      void
      remove (
        /* in */const ::std::string& key
      )
      ;



      /**
       *  
       * Get all the names associated with a particular type
       * without exposing the data implementation details.  The keys
       * will be returned in an arbitrary order. If type specified is
       * NoType (no specification) all keys of all types are returned.
       */
      ::sidl::array< ::std::string>
      getAllKeys (
        /* in */::gov::cca::Type t
      )
      ;



      /**
       *  Return true if the key exists in this map 
       */
      bool
      hasKey (
        /* in */const ::std::string& key
      )
      ;



      /**
       *  Return the type of the value associated with this key 
       */
      ::gov::cca::Type
      typeOf (
        /* in */const ::std::string& key
      )
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct gov_cca_TypeMap__object ior_t;
      typedef struct gov_cca_TypeMap__external ext_t;
      typedef struct gov_cca_TypeMap__sepv sepv_t;

      // default constructor
      TypeMap()  : gov_cca_TypeMap_IORCache((ior_t*) NULL){ }

#ifdef WITH_RMI

      // RMI connect
      static inline ::gov::cca::TypeMap _connect( /*in*/ const std::string& url 
        ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::gov::cca::TypeMap _connect( /*in*/ const std::string& url, 
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~TypeMap () { }

      // copy constructor
      TypeMap ( const TypeMap& original );

      // assignment operator
      TypeMap& operator= ( const TypeMap& rhs );

      // conversion from ior to C++ class
      TypeMap ( TypeMap::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      TypeMap ( TypeMap::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        if(!gov_cca_TypeMap_IORCache) { 
          gov_cca_TypeMap_IORCache = ::gov::cca::TypeMap::_cast((void*)d_self);
          if (gov_cca_TypeMap_IORCache) {
            struct sidl_BaseInterface__object *throwaway_exception;
            (gov_cca_TypeMap_IORCache->d_epv->f_deleteRef)(
              gov_cca_TypeMap_IORCache->d_object, &throwaway_exception);  
          }  
        }
        return gov_cca_TypeMap_IORCache;
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);
        gov_cca_TypeMap_IORCache = (ior_t*) ptr;

      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "gov.cca.TypeMap";}

      static struct gov_cca_TypeMap__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);

      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable interface contract enforcement.
       */
      void
      _set_contracts (
        /* in */bool enable,
        /* in */const ::std::string& enfFilename,
        /* in */bool resetCounters
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to dump contract enforcement statistics.
       */
      void
      _dump_stats (
        /* in */const ::std::string& filename,
        /* in */const ::std::string& prefix
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


      //////////////////////////////////////////////////
      // 
      // Locally Cached IOR pointer
      // 

    protected:
      mutable ior_t* gov_cca_TypeMap_IORCache;
    }; // end class TypeMap
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_TypeMap__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_TypeMap__object*
  gov_cca_TypeMap__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::TypeMap > {
    typedef array< ::gov::cca::TypeMap > cxx_array_t;
    typedef ::gov::cca::TypeMap cxx_item_t;
    typedef struct gov_cca_TypeMap__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_TypeMap__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::gov::cca::TypeMap > > iterator;
    typedef const_array_iter< array_traits< ::gov::cca::TypeMap > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::TypeMap >: public interface_array< array_traits< 
    ::gov::cca::TypeMap > > {
  public:
    typedef interface_array< array_traits< ::gov::cca::TypeMap > > Base;
    typedef array_traits< ::gov::cca::TypeMap >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::gov::cca::TypeMap >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::gov::cca::TypeMap >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::gov::cca::TypeMap >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::gov::cca::TypeMap >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_TypeMap__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::TypeMap >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::TypeMap >&
    operator =( const array< ::gov::cca::TypeMap >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
