// 
// File:          gov_cca_ports_ServiceRegistry.hxx
// Symbol:        gov.cca.ports.ServiceRegistry-v0.8.5
// Symbol Type:   interface
// Babel Version: 1.4.0
// Description:   Client-side glue code for gov.cca.ports.ServiceRegistry
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_gov_cca_ports_ServiceRegistry_hxx
#define included_gov_cca_ports_ServiceRegistry_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ServiceRegistry;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::gov::cca::ports::ServiceRegistry >;
}
// 
// Forward declarations for method dependencies.
// 
namespace gov { 
  namespace cca { 

    class CCAException;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 

    class Port;
  } // end namespace cca
} // end namespace gov

namespace gov { 
  namespace cca { 
    namespace ports { 

      class ServiceProvider;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_gov_cca_ports_ServiceRegistry_IOR_h
#include "gov_cca_ports_ServiceRegistry_IOR.h"
#endif
#ifndef included_gov_cca_Port_hxx
#include "gov_cca_Port.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.ServiceRegistry" (version 0.8.5)
       * 
       * ServiceRegistry is a Port that is provided by the framework
       * and can be used by a component wishing to provide service Ports. 
       */
      class ServiceRegistry: public virtual ::gov::cca::Port {

        //////////////////////////////////////////////////
        // 
        // Special methods for throwing exceptions
        // 

      private:
        static 
        void
        throwException1(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
        ;
        static 
        void
        throwException0(
          const char* methodName,
          struct sidl_BaseInterface__object *_exception
        )
          // throws:
          //    ::gov::cca::CCAException
          //    ::sidl::RuntimeException
        ;

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         * Add a ServiceProvider that can be asked to produce service Port's
         * for other components to use subsequently.
         * True means success. False means that for some reason, the
         * provider isn't going to function. Possibly another server is doing
         * the job.
         */
        bool
        addService (
          /* in */const ::std::string& serviceType,
          /* in */const ::gov::cca::ports::ServiceProvider& portProvider
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Add a "reusable" service gov.cca.Port for other components to use 
         * subsequently.
         */
        bool
        addSingletonService (
          /* in */const ::std::string& serviceType,
          /* in */const ::gov::cca::Port& server
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        /**
         *  Inform the framework that this service Port is no longer to
         * be used, subsequent to this call. 
         */
        void
        removeService (
          /* in */const ::std::string& serviceType
        )
        // throws:
        //    ::gov::cca::CCAException
        //    ::sidl::RuntimeException
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_ServiceRegistry__object ior_t;
        typedef struct gov_cca_ports_ServiceRegistry__external ext_t;
        typedef struct gov_cca_ports_ServiceRegistry__sepv sepv_t;

        // default constructor
        ServiceRegistry()  : gov_cca_ports_ServiceRegistry_IORCache((ior_t*) 
          NULL){ }

#ifdef WITH_RMI

        // RMI connect
        static inline ::gov::cca::ports::ServiceRegistry _connect( /*in*/ const 
          std::string& url ) { 
          return _connect(url, true);
        }

        // RMI connect 2
        static ::gov::cca::ports::ServiceRegistry _connect( /*in*/ const 
          std::string& url, /*in*/ const bool ar  );


#endif /*WITH_RMI*/

        // default destructor
        virtual ~ServiceRegistry () { }

        // copy constructor
        ServiceRegistry ( const ServiceRegistry& original );

        // assignment operator
        ServiceRegistry& operator= ( const ServiceRegistry& rhs );

        // conversion from ior to C++ class
        ServiceRegistry ( ServiceRegistry::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        ServiceRegistry ( ServiceRegistry::ior_t* ior, bool isWeak );

        inline ior_t* _get_ior() const throw() {
          if(!gov_cca_ports_ServiceRegistry_IORCache) { 
            gov_cca_ports_ServiceRegistry_IORCache = 
              ::gov::cca::ports::ServiceRegistry::_cast((void*)d_self);
            if (gov_cca_ports_ServiceRegistry_IORCache) {
              struct sidl_BaseInterface__object *throwaway_exception;
              (gov_cca_ports_ServiceRegistry_IORCache->d_epv->f_deleteRef)(
                gov_cca_ports_ServiceRegistry_IORCache->d_object, 
                &throwaway_exception);  
            }  
          }
          return gov_cca_ports_ServiceRegistry_IORCache;
        }

        inline void _set_ior( ior_t* ptr ) throw () { 
          d_self = reinterpret_cast< void*>(ptr);
          gov_cca_ports_ServiceRegistry_IORCache = (ior_t*) ptr;

          gov_cca_Port_IORCache = NULL;
        }

        virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                       const ::std::type_info &argtype );

        bool _is_nil() const throw () { return (d_self==0); }

        bool _not_nil() const throw () { return (d_self!=0); }

        bool operator !() const throw () { return (d_self==0); }

        static inline const char * type_name() throw () { return 
          "gov.cca.ports.ServiceRegistry";}

        static struct gov_cca_ports_ServiceRegistry__object* _cast(const void* 
          src);

        // execute member function by name
        void _exec(const std::string& methodName,
                   ::sidl::rmi::Call& inArgs,
                   ::sidl::rmi::Return& outArgs);

        /**
         * Get the URL of the Implementation of this object (for RMI)
         */
        ::std::string
        _getURL() // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable method hooks invocation.
         */
        void
        _set_hooks (
          /* in */bool enable
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to enable/disable interface contract enforcement.
         */
        void
        _set_contracts (
          /* in */bool enable,
          /* in */const ::std::string& enfFilename,
          /* in */bool resetCounters
        )
        // throws:
        //    ::sidl::RuntimeException
        ;


        /**
         * Method to dump contract enforcement statistics.
         */
        void
        _dump_stats (
          /* in */const ::std::string& filename,
          /* in */const ::std::string& prefix
        )
        // throws:
        //    ::sidl::RuntimeException
        ;

        // return true iff object is remote
        bool _isRemote() const { 
          ior_t* self = const_cast<ior_t*>(_get_ior() );
          struct sidl_BaseInterface__object *throwaway_exception;
          return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == 
            TRUE;
        }

        // return true iff object is local
        bool _isLocal() const {
          return !_isRemote();
        }

      protected:
        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );


        //////////////////////////////////////////////////
        // 
        // Locally Cached IOR pointer
        // 

      protected:
        mutable ior_t* gov_cca_ports_ServiceRegistry_IORCache;
      }; // end class ServiceRegistry
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

extern "C" {


#pragma weak gov_cca_ports_ServiceRegistry__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct gov_cca_ports_ServiceRegistry__object*
  gov_cca_ports_ServiceRegistry__connectI(const char * url, sidl_bool ar, 
    struct sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::ServiceRegistry > {
    typedef array< ::gov::cca::ports::ServiceRegistry > cxx_array_t;
    typedef ::gov::cca::ports::ServiceRegistry cxx_item_t;
    typedef struct gov_cca_ports_ServiceRegistry__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_ServiceRegistry__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::gov::cca::ports::ServiceRegistry > > 
      iterator;
    typedef const_array_iter< array_traits< ::gov::cca::ports::ServiceRegistry 
      > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::ServiceRegistry >: public interface_array< 
    array_traits< ::gov::cca::ports::ServiceRegistry > > {
  public:
    typedef interface_array< array_traits< ::gov::cca::ports::ServiceRegistry > 
      > Base;
    typedef array_traits< ::gov::cca::ports::ServiceRegistry >::cxx_array_t     
      cxx_array_t;
    typedef array_traits< ::gov::cca::ports::ServiceRegistry >::cxx_item_t      
      cxx_item_t;
    typedef array_traits< ::gov::cca::ports::ServiceRegistry >::ior_array_t     
      ior_array_t;
    typedef array_traits< ::gov::cca::ports::ServiceRegistry 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::ServiceRegistry >::ior_item_t      
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_ServiceRegistry__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::ServiceRegistry >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::ServiceRegistry >&
    operator =( const array< ::gov::cca::ports::ServiceRegistry >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#ifndef included_gov_cca_ports_ServiceProvider_hxx
#include "gov_cca_ports_ServiceProvider.hxx"
#endif
#endif
