/*
 * File:          gov_cca_AbstractFramework_jniStub.h
 * Symbol:        gov.cca.AbstractFramework-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Client-side header code for gov.cca.AbstractFramework
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#ifndef included_gov_cca_AbstractFramework_jniStub_h
#define included_gov_cca_AbstractFramework_jniStub_h

/**
 * Symbol "gov.cca.AbstractFramework" (version 0.8.5)
 * 
 *  
 * This is an interface presented by a CCA-compliant framework to access its 
 * application framing capabilities. Most of the manipulation of the 
 * underlying framework is expected to be be done with the 
 * gov.cca.BuilderService Port. This class exists as a sort of bootstrap 
 * to get a Services object necessary to retrieve Port's, including 
 * BuilderService, from the underlying framework. How the interface and 
 * the underlying framework is created is entirely unspecified and is up 
 * to the devices of the programmer and the framework provider.
 * 
 * <p>Example</p>
 * <p>
 * Here it is assumed that an instance of AbstractFramework
 * is created in the main() from some hypothetical implementation.
 * The idea is to allow a complete swap of framework choice by 
 * changing out the specified implementation class of a framework.
 * </p>
 * 
 * <code><pre>
 * // java
 * main() {
 * cca.reference.Framework fwkimpl = new cca.reference.Framework();
 * // change fwkimpl above to use different cca implementations when
 * // AbstractFramework becomes part of the standard.
 * gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;
 * gov.cca.Services svc = 
 * fwk.getServices("instance0","AppDriver",null);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk.releaseServices(svc);
 * fwk.shutdownFramework();
 * }
 * 
 * // c++
 * int functionName() {
 * ::gov::sandia::ccafe::Framework fwkimpl;
 * ::gov::cca::AbstractFrameworkPtr fwk;
 * 
 * fwk = fwkimpl.getStandardFramework();
 * ::gov::cca::Services_Interface  svc = 0;
 * svc = fwk->getServices("instance0","AppDriver",0);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk->releaseServices(svc);
 * svc = 0;
 * fwk->shutdownFramework();
 * 
 * // at scope exit, all memory is automatically cleaned up.
 * }
 * </pre></code>
 */

#ifndef included_gov_cca_AbstractFramework_IOR_h
#include "gov_cca_AbstractFramework_IOR.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif


#pragma weak gov_cca_AbstractFramework__connectI

/**
 * RMI connector function for the class. (no addref)
 */
struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__connectI(const char * url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex);

#ifdef __cplusplus
}
#endif
#endif
